//package extensions.generic;

import extensions.generic.*;
import org.escience.XSIL.*;
import java.awt.*;
import java.util.Vector;
import java.util.Enumeration;
import java.util.HashMap;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.lang.Object;
import java.io.*;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.applet.MainFrame;
//import com.sun.j3d.utils.behaviors.picking.*;


public class Java3DViewer extends Applet
    implements ActionListener, ItemListener {

  static extensions.generic.parseXMLList parsexmllist;
  static XSIL root;
  static extensions.generic.Plot3D plot3d;
  String xmlpath = "c:\\GOW\\WEB-INF\\src\\generic\\molecules.xml";
  HashMap[] molecules;
  HashMap axisData;
  HashMap NormalMode;

  private extensions.generic.CapturingCanvas3D canvasXYZ;
  private VirtualUniverse universe;
  private Locale locale;
  private extensions.generic.renderingObject3D renderobject3d;

  private Choice applist; 

  private TextField transX;
  private TextField transY;
  private TextField transZ;
  private TextField rotangle;
  private Checkbox rotxy;
  private TextField scaleX;

  private List list;
  private Label label;

  //Planes of transformations
  private static final int XY = 1,
                           XZ = 2,
                           YZ = 3;
  //The transform types
  private static final int TRANSLATE = 1,
                           ROTATE = 2,
                           SCALE = 3;

  private int MODE; //the current transform mode
  private int lastX = 0, lastY = 0;
  private int plane;
  private int Numberofappl;
  private int moleculecount;
  private boolean Normal_mode; 

  //Normal Mode type definition
  private final float[][] Mode1 = { {0.00f, 0.00f, -0.24f}, {0.00f, 0.00f, -0.89f},
	  			{0.00f, 0.00f, 0.31f}, {0.00f, 0.00f, -0.06f},
	  			{0.00f, 0.00f, -0.09f}, {-0.02f, -0.14f, 0.03f},
	  			{0.02f, 0.14f, 0.03f} };
  private final float[][] Mode2 = { {-0.02f, 0.03f, 0.00f}, {-0.03f, 0.43f, 0.00f},
	  			{0.45f, -0.27f, 0.00f}, {-0.22f, -0.04f, 0.00f},
	  			{-0.21f, 0.60f, 0.00f}, {-0.01f, -0.20f, 0.05f},
	  			{-0.01f, -0.20f, -0.05f} };
  private final float[][] Mode3 = { {0.00f, 0.00f, 0.23f}, {0.00f, 0.00f, 0.88f},
	  			{0.00f, 0.00f, 0.06f}, {0.00f, 0.00f, -0.08f},
	  			{0.00f, 0.00f, -0.17f}, {0.19f, -0.18f, -0.01f},
	  			{-0.19f, 0.18f, -0.01f} };
  private final float[][] Mode4 = { {0.21f, 0.19f, 0.00f}, {0.22f, -0.02f, 0.00f},
	  			{-0.12f, 0.42f, 0.00f}, {0.19f, 0.11f, 0.00f},
	  			{0.20f, 0.07f, 0.00f}, {-0.18f, -0.31f, 0.41f},
	  			{-0.18f, -0.31f, -0.41f} };
  private final float[][] Mode5 = { {0.00f, 0.00f, 0.08f}, {0.00f, 0.00f, 0.76f},
	  			{0.00f, 0.00f, 0.05f}, {0.00f, 0.00f, -0.32f},
	  			{0.00f, 0.00f, 0.34f}, {-0.21f, -0.20f, -0.13f},
	  			{0.21f, 0.20f, -0.13f} };
  private final float[][] Mode6 = { {0.07f, -0.33f, 0.00f}, {0.08f, -0.54f, 0.00f},
	  			{-0.04f, -0.29f, 0.00f}, {0.31f, -0.11f, 0.00f},
	  			{0.35f, 0.23f, 0.00f}, {-0.28f, 0.16f, 0.01f},
	  			{-0.28f, 0.16f, -0.01f} };   
  private final float[][] Mode7 = { {-0.43f, 0.02f, 0.00f}, {-0.44f, 0.18f, 0.00f},
	  			{0.10f, -0.37f, 0.00f}, {0.02f, 0.40f, 0.00f},
	  			{0.04f, -0.17f, 0.00f}, {0.08f, 0.11f, 0.33f},
	  			{0.08f, 0.11f, -0.33f} };
  private final float[][] Mode8 = { {0.39f, -0.30f, 0.00f}, {0.41f, -0.66f, 0.00f},
	  			{-0.07f, -0.03f, 0.00f}, {-0.02f, 0.08f, 0.00f},
	  			{-0.29f, 0.01f, 0.00f}, {0.05f, 0.09f, 0.14f},
	  			{0.05f, 0.09f, -0.14f} };
  private final float[][] Mode9 = { {0.00f, 0.00f, 0.25f}, {0.00f, 0.00f, -0.96f},
	  			{0.00f, 0.00f, -0.06f}, {0.00f, 0.00f, 0.01f},
	  			{0.00f, 0.00f, 0.01f}, {-0.01f, -0.04f, -0.04f},
	  			{0.01f, 0.04f, -0.04f} };
  private final float[][] Mode10 = { {0.08f, -0.07f, 0.00f}, {0.12f, -0.69f, 0.00f},
	  			 {0.01f, -0.05f, 0.00f}, {-0.05f, 0.63f, 0.00f},
	  			 {0.07f, -0.01f, 0.00f}, {-0.05f, -0.13f, -0.16f},
	  			 {-0.05f, -0.13f, 0.16f} };
  private final float[][] Mode11 = { {0.00f, 0.00f, -0.10f}, {0.00f, 0.00f, 0.39f},
	  			 {0.00f, 0.00f, 0.02f}, {0.00f, 0.00f, 0.81f},
	  			 {0.00f, 0.00f, -0.01f}, {-0.07f, -0.16f, -0.24f},
	  			 {0.07f, 0.16f, -0.24f} };
  private final float[][] Mode12 = { {-0.16f, 0.12f, 0.00f}, {-0.14f, -0.80f, 0.00f},
	  			 {0.08f, 0.03f, 0.00f}, {0.49f, -0.01f, 0.00f},
	  			 {-0.23f, 0.00f, 0.00f}, {-0.02f, -0.03f, -0.04f},
	  			 {-0.02f, -0.03f, 0.04f} };
  private final float[][] Mode13 = { {0.05f, -0.04f, 0.00f}, {0.03f, 0.98f, 0.00f},
	  			 {-0.06f, -0.04f, 0.00f}, {0.14f, 0.07f, 0.00f},
	  			 {-0.05f, 0.00f, 0.00f}, {-0.01f, -0.01f, -0.02f},
	  			 {-0.01f, -0.01f, 0.02f} };
  private final float[][] Mode14 = { {0.30f, 0.62f, 0.00f}, {0.43f, -0.34f, 0.00f},
	  			 {-0.25f, -0.40f, 0.00f}, {-0.01f, -0.05f, 0.00f},
	  			 {0.00f, 0.00f, 0.00f}, {0.00f, 0.00f, 0.00f},
	  			 {0.00f, 0.00f, 0.00f} };
  private final float[][] Mode15 = { {-0.09f, -0.01f, 0.00f}, {1.00f, 0.04f, 0.00f},
	  			 {0.00f, 0.00f, 0.00f}, {0.00f, 0.00f, 0.00f},
	  			 {0.00f, 0.00f, 0.00f}, {0.00f, 0.00f, 0.00f},
	  			 {0.00f, 0.00f, 0.00f} };

  //doTransform variable
  private static final int TotalTG = 50;
  private TransformGroup doTranstg;
  private HashMap doTranstmp;
  private TransformGroup[] doTranstgarray;
  private Transform3D doTranst3d;
  private Transform3D[] doTranst3darray;
  private Vector3d doTransv;
  private Vector3d[] doTransvarray;
  private Vector3d doTransvv;
  private Vector3d[] doTransvvarray;
  private Matrix4d doTransm;
  private Vector3d doTransaxis;
  private AxisAngle4d doTransaa;


  public Java3DViewer() { }

  public void init() {

      boolean ss = true;
      root = new XSIL(xmlpath,ss);
      XSIL child;
      
      for(int ichild=0;ichild<root.getChildCount();ichild++) {
	  child = root.getChild(ichild);
	  parsexmllist = (extensions.generic.parseXMLList)child;
      }

      Vector geometryName = parsexmllist.getParseXMLgeometriesName();
      Numberofappl = geometryName.size();
      
      String chooseMolecule = "3DGeometry2";

      plane = XY;
      moleculecount = 0;
      Normal_mode = false;	  
	  NormalMode = new HashMap();
   
      //doTransform Method ==> Variable initialize
      doTranstg = new TransformGroup();
      setCapabilities(doTranstg);
      doTranstmp = new HashMap();
      doTranstgarray = new TransformGroup[TotalTG];
      doTranst3d = new Transform3D();
      doTranst3darray = new Transform3D[TotalTG];
      doTransv = new Vector3d();
      doTransvv = new Vector3d();
      doTransvarray = new Vector3d[TotalTG];
      doTransvvarray = new Vector3d[TotalTG];
      doTransm = new Matrix4d();
      doTransaxis = new Vector3d();
      doTransaa = new AxisAngle4d();    

      for(int i=0; i<TotalTG; i++) {
        doTranstgarray[i] = new TransformGroup();
        setCapabilities(doTranstgarray[i]);
        doTranst3darray[i] = new Transform3D();
        doTransvarray[i] = new Vector3d();
        doTransvvarray[i] = new Vector3d();
      }

       //rendering Objects are invoked
       renderobject3d = new extensions.generic.renderingObject3D();

       setLayout(new BorderLayout());

       ControlPanelBox();

	  list.add(chooseMolecule);
	  molecules = new HashMap[Numberofappl];
	  for( int i=0; i<Numberofappl; i++) {
	  	 molecules[i] = new HashMap();
	  	 molecules[i].put("MOLECULE_ID", (String)geometryName.elementAt(i));
	  	 applist.add((String)geometryName.elementAt(i));
	  }

	  for(int i=0; i<Numberofappl; i++)
	    System.out.println("ID: "+molecules[i].get("MOLECULE_ID"));

      universe = new VirtualUniverse();
      locale = new Locale( universe );

      label.setText("Mode: Translate");
      MODE = TRANSLATE;//SCALE; ROTATE; TRANSLATE;

      locale.addBranchGraph(createViewplatformGraph(canvasXYZ));

//      BranchGroup scene = createSceneGraph(chooseMolecule);

	  axisData = createAxis();
	  for(int i=0; i<Numberofappl; i++)
	  	if(((String)molecules[i].get("MOLECULE_ID")).equals(chooseMolecule)) {
           molecules[i] = createSceneGraph(chooseMolecule);
           molecules[i].put("MOLECULE_ID", chooseMolecule);
           System.out.println("HashMap: "+molecules[i].toString());
           break;
        }     

      //create some ambience
      BranchGroup bg = new BranchGroup();
      bg.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      bg.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      Color3f lColor1 = new Color3f(1.0f, 1.0f, 1.0f);
      Vector3f lDir1  = new Vector3f(-1.0f, -1.0f, -1.0f);
      Color3f alColor = new Color3f(0.2f, 0.2f, 0.2f);
      
      AmbientLight al = new AmbientLight( alColor );
      BoundingSphere bounds =
         new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0);
      al.setInfluencingBounds( bounds );
      DirectionalLight lgt1 = new DirectionalLight(lColor1, lDir1);
      lgt1.setInfluencingBounds(bounds);

      bg.addChild( al );
      bg.addChild( lgt1 );
      locale.addBranchGraph( bg );

//      scene.compile();
//      locale.addBranchGraph( scene );

      initTRS(chooseMolecule);

  }

  private void ControlPanelBox() {

	Panel Java3DViewerPanel = new Panel();

    GraphicsConfiguration config =
	          SimpleUniverse.getPreferredConfiguration();
	canvasXYZ = new extensions.generic.CapturingCanvas3D(config);

    Panel ControlPanel = new Panel ();

    Panel applications = new Panel ();
  	applist = new Choice();
	Button axison = new Button("AxisOn");
	Button axisoff = new Button("AxisOff");

	Panel filepanel = new Panel();
	Button save = new Button("Save/JPG");
    Button save1 = new Button("Save/Coord");
    Button remove = new Button("Remove");    

    Panel transpanel = new Panel ();
    Button translate = new Button ("Translate");
 	transX = new TextField("",5);
	transY = new TextField("",5);
    transZ = new TextField("",5);
	Label ltransX = new Label("     X:");
  	Label ltransY = new Label("     Y:");
  	Label ltransZ = new Label("     Z:");
	Label transTitle = new Label("== Translate Control ==");

	Panel rotpanel = new Panel();
    Button rotate = new Button ("Rotate");
	rotangle = new TextField("",5);
	CheckboxGroup rotg = new CheckboxGroup();
	rotxy = new Checkbox("XY", rotg, true);
	Checkbox rotyz = new Checkbox("YZ", rotg, false);
	Checkbox rotxz = new Checkbox("XZ", rotg, false);	
	Label lrotangle = new Label("  Angle:");
	Label rotTitle = new Label("== Rotate Control ==");

	Panel scalepanel = new Panel();
    Button scale = new Button ("Scale");
	scaleX = new TextField("",5);
	Label lscaleX = new Label("Scale Level:");
	Label scaleTitle = new Label("== Scale Control ==");

    Panel menulist = new Panel ();
    list = new List ();
    label = new Label ();

	Panel normalmode = new Panel();
	Button normon = new Button("NormalOn");
	Button normoff = new Button("NormalOff");
    Choice normselect = new Choice();
    normselect.add("Mode1");
    normselect.add("Mode2");
    normselect.add("Mode3");
    normselect.add("Mode4");
    normselect.add("Mode5");	
    normselect.add("Mode6");
    normselect.add("Mode7");
    normselect.add("Mode8");
    normselect.add("Mode9");
    normselect.add("Mode10");	
    normselect.add("Mode11");
    normselect.add("Mode12");
    normselect.add("Mode13");
    normselect.add("Mode14");
    normselect.add("Mode15");
	//normselect.select("Mode1");

    normselect.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
					
		 if(Normal_mode) {
		 	BranchGroup bg;
		 	
            if(evt.getStateChange() == ItemEvent.SELECTED) {
			    System.out.println("Selected: "+ (String)evt.getItem());
			    if(((String)evt.getItem()).equals("Mode1")) {	
 					bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			    	locale.removeBranchGraph(bg);			    			    			    	
			    	NormalMode = createSceneGraphAnimation(Mode1);
			    }	
			    else if(((String)evt.getItem()).equals("Mode2")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode2);
			    }
			    else if(((String)evt.getItem()).equals("Mode3")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode3);
			    }
			    else if(((String)evt.getItem()).equals("Mode4")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode4);
			    }
			    else if(((String)evt.getItem()).equals("Mode5")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode5);
			    }
			    else if(((String)evt.getItem()).equals("Mode6")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode6);
			    }
			    else if(((String)evt.getItem()).equals("Mode7")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode7);
			    }
			    else if(((String)evt.getItem()).equals("Mode8")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode8);
			    }
			    else if(((String)evt.getItem()).equals("Mode9")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode9);
			    }
			    else if(((String)evt.getItem()).equals("Mode10")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode10);
			    }
			    else if(((String)evt.getItem()).equals("Mode11")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode11);
			    }
			    else if(((String)evt.getItem()).equals("Mode12")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode12);
			    }
			    else if(((String)evt.getItem()).equals("Mode13")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode13);
			    }
			    else if(((String)evt.getItem()).equals("Mode14")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode14);
			    }
			    else if(((String)evt.getItem()).equals("Mode15")) {			        
			        bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			        locale.removeBranchGraph(bg);
			        NormalMode = createSceneGraphAnimation(Mode15);
			    }			    
			}    

	     } else {
			 	System.out.println("It is NOT a Normal Mode!!!!");
			 	return;
		 }
		 	
		}
	});    
    	    

    Java3DViewerPanel.setLayout (new GridLayout ());
    //Java3DViewerPanel.setBackground (new java.awt.Color (204, 204, 204));
    //Java3DViewerPanel.setForeground (java.awt.Color.black);
    Java3DViewerPanel.setName ("Java3DViewer");
    Java3DViewerPanel.setFont (new Font ("Dialog", 0, 11));

    canvasXYZ.setBackground (Color.white);
    canvasXYZ.setName ("canvasXYZ");

    canvasXYZ.addMouseListener (new MouseAdapter () {
        public void mousePressed (MouseEvent evt) {
                canvasXYMousePressed (evt);
        }
       });
        
    canvasXYZ.addMouseMotionListener (new MouseMotionAdapter () {
        public void mouseDragged (MouseEvent evt) {
            if(!Normal_mode) canvasXYMouseDragged (evt);
            else {
                	System.out.println("It has the Normal Mode!!!");
                	return;
           }	            
                  //canvasXZMouseDragged (evt);
                  //canvasYZMouseDragged (evt);
        }
       });
  
    Java3DViewerPanel.add (canvasXYZ);
    add(Java3DViewerPanel, BorderLayout.CENTER);

    ControlPanel.setLayout (new GridLayout (7, 1));
    //ControlPanel1.setBackground (new java.awt.Color (204, 204, 204));
    //ControlPanel1.setForeground (java.awt.Color.black);
    ControlPanel.setName ("ControlPanel");
    ControlPanel.setFont (new Font ("Dialog", 0, 11));

  	applications.setLayout(new FlowLayout (FlowLayout.LEFT));
    applications.setBackground (new Color (204, 204, 204));
    applications.setForeground (Color.black);
    applications.setName ("Applications");
    applications.setFont (new Font ("Dialog", 0, 11));
  
	applist.addItemListener(this);
	applications.add(applist);
    
    axison.setFont (new Font ("Dialog", 0, 11));
    axison.addActionListener (this);
    applications.add (axison);

    axisoff.setFont (new Font ("Dialog", 0, 11));
    axisoff.addActionListener (this);
    applications.add (axisoff);
    
    ControlPanel.add (applications);

  	filepanel.setLayout(new FlowLayout (FlowLayout.LEFT));
    filepanel.setBackground (new Color (204, 204, 204));
    filepanel.setForeground (Color.black);
    filepanel.setName ("Applications");
    filepanel.setFont (new Font ("Dialog", 0, 11));

    save.setFont (new Font ("Dialog", 0, 11));
    save.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			canvasXYZ.writeJPEG_ = true;
			canvasXYZ.repaint();
		}
	});
 
	filepanel.add(save);

    save1.setFont (new Font ("Dialog", 0, 11));
    save1.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			 if(!Normal_mode) writeCoordtoFile();
			 else {
			 	System.out.println("It has the Normal Mode!!!!");
			 	return;
			 }	
		}
	});
 
	filepanel.add(save1);
	
    remove.setFont (new Font ("Dialog", 0, 11));
    remove.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		  if(!Normal_mode) {	
			String sallitems[] = list.getSelectedItems();
			if(sallitems.length == 0) {
				System.out.println("You don't have the selected item!!!");
				return;
			}
				
			for(int i=0; i<sallitems.length; i++)
			    for(int j=0; j<molecules.length; j++)
			      if(((String)molecules[j].get("MOLECULE_ID")).equals(sallitems[i])) {
			      	BranchGroup bg = (BranchGroup)molecules[j].get(sallitems[i]+"BG");
			      	locale.removeBranchGraph(bg);
			        list.remove(sallitems[i]);
			      }
		  } else {
		  	System.out.println("It has the Normal Mode!!!!");
		  	return;
		  }		        			          
		}
	});
 
	filepanel.add(remove);

	ControlPanel.add(filepanel);

	GridBagConstraints gbc = new GridBagConstraints();

	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.weightx = 100;
	gbc.weighty = 100;

    transpanel.setLayout (new GridBagLayout());
    transpanel.setBackground (new Color (204, 204, 204));
    transpanel.setForeground (Color.black);
    transpanel.setName ("Translate");
    //transpanel.setFont (new Font ("Dialog", 0, 11));
  	
    translate.setFont (new Font ("Dialog", 0, 11));
    translate.addActionListener (this);

	//transX.setFont (new Font ("Dialog", 0, 11));
	//transX.addActionListener(this);
	add(transpanel, transTitle, gbc, 0,0,4,1);
	add(transpanel, ltransX, gbc, 0,1,1,1);
	add(transpanel, transX, gbc, 1,1,1,1);
	add(transpanel, ltransY, gbc, 2,1,1,1);
	add(transpanel, transY, gbc, 3,1,1,1);
	add(transpanel, ltransZ, gbc, 0,2,1,1);
	add(transpanel, transZ, gbc, 1,2,1,1);
	add(transpanel, translate, gbc, 2,2,1,1);
	
	/*
	transpanel.add(ltransX);
	transpanel.add(transX);
	transpanel.add(ltransY);
	transpanel.add(transY);
	transpanel.add(translate);
	*/
	ControlPanel.add(transpanel);

    rotpanel.setLayout (new GridBagLayout());
    rotpanel.setBackground (new Color (204, 204, 204));
    rotpanel.setForeground (Color.black);
    rotpanel.setName ("Rotate");

	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.weightx = 100;
	gbc.weighty = 100;

    rotate.setFont (new Font ("Dialog", 0, 11));
    rotate.addActionListener (this);

	//rotangle.setFont (new Font ("Dialog", 0, 11));
	//rotangle.addActionListener(this);
	add(rotpanel, rotTitle, gbc, 0,0,3,1);
	add(rotpanel, rotxy, gbc, 0,1,1,1);
	add(rotpanel, rotyz, gbc, 1,1,1,1);
	add(rotpanel, rotxz, gbc, 2,1,1,1);
	rotxy.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			plane = XY;
		}
	});
	rotyz.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			plane = YZ;
		}
	});
	rotxz.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			plane = XZ;
		}
	});

	//gbc.anchor = GridBagConstraints.EAST;
	add(rotpanel, lrotangle, gbc, 0,2,1,1);
	//gbc.anchor = GridBagConstraints.WEST;
 	add(rotpanel, rotangle, gbc, 1,2,1,1);
	add(rotpanel, rotate, gbc, 2,2,1,1);	  
	ControlPanel.add(rotpanel);

	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.weightx = 100;
	gbc.weighty = 100;

    scalepanel.setLayout (new GridBagLayout());
    scalepanel.setBackground (new Color (204, 204, 204));
    scalepanel.setForeground (Color.black);
    scalepanel.setName ("Scale");

    scale.setFont (new Font ("Dialog", 0, 11));
    scale.addActionListener (this);

	//scalefactor.setFont (new Font ("Dialog", 0, 11));
	//scalefactor.addActionListener(this);
	add(scalepanel, scaleTitle, gbc, 0,0,3,1);
	add(scalepanel, lscaleX, gbc, 0,1,1,1);
	add(scalepanel, scaleX, gbc, 1,1,1,1);
	add(scalepanel, scale, gbc, 2,1,1,1);
	/*
	scalepanel.add(lscaleX);
	scalepanel.add(scaleX);
	scalepanel.add(scale);
    */

    ControlPanel.add (scalepanel);
  
    menulist.setLayout (new FlowLayout (FlowLayout.LEFT));
    menulist.setBackground (new Color (204, 204, 204));
    menulist.setForeground (Color.black);
    menulist.setName ("Menu List");
    menulist.setFont (new Font ("Dialog", 0, 11));
  
    list.setBackground (Color.white);
    list.setForeground (Color.black);
    list.setName ("list1");
    list.setFont (new Font ("Dialog", 0, 11));
    //allow multiple selections:
    list.setMultipleMode( true );
	//list.add("Gamess");
    
    menulist.add (list);
    
    ControlPanel.add (menulist);

    normalmode.setLayout (new FlowLayout (FlowLayout.LEFT));
    normalmode.setBackground (new Color (204, 204, 204));
    normalmode.setForeground (Color.black);
    normalmode.setName ("Menu List");
    normalmode.setFont (new Font ("Dialog", 0, 11));   
    
    normon.setFont (new Font ("Dialog", 0, 11));
    normon.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {

		  if(!Normal_mode) {	
			String allitems[] = list.getItems();
			
		    Normal_mode = true;
			label.setText("Normal Mode");
			if(allitems.length == 0) {
				System.out.println("You don't have the items!!!");
				NormalMode = createSceneGraphAnimation(Mode1);
				return;
			}
				
			for(int i=0; i<allitems.length; i++)
			    for(int j=0; j<molecules.length; j++)
			      if(((String)molecules[j].get("MOLECULE_ID")).equals(allitems[i])) {
			      	BranchGroup bg = (BranchGroup)molecules[j].get(allitems[i]+"BG");
			      	locale.removeBranchGraph(bg);
			        list.remove(allitems[i]);
			      }
			NormalMode = createSceneGraphAnimation(Mode1);		
						      
		  } else {
		  	System.out.println("You are in the Normal Mode already!!!");
		  	return;
		  }		        			          
	
		}
	});
	
    normoff.setFont (new Font ("Dialog", 0, 11));
    normoff.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {

			if(Normal_mode) {
			    Normal_mode = false;
			    label.setText("Mode: Translate");
			    BranchGroup bg = (BranchGroup)NormalMode.get("3DGeometry4BG");
			    locale.removeBranchGraph(bg);			    
	        } else {
	        	System.out.println("You are not in the Normal Mode!!!");
	        	return;
	        }	
		}
	});
 
	normalmode.add(normon); 
	normalmode.add(normoff); 	  
    
    normalmode.add(normselect);
    ControlPanel.add (normalmode);    

    add (ControlPanel, BorderLayout.EAST);

    label.setBackground (new Color (204, 204, 204));
    label.setText ("Mode:");
    label.setForeground (Color.black);
    label.setName ("mode");
    label.setFont (new Font ("Dialog", 0, 11));

    add (label, BorderLayout.SOUTH);

  }

  public void itemStateChanged(ItemEvent evt) {
  	
   if(!Normal_mode) {	
    if(evt.getStateChange() == ItemEvent.SELECTED) {
            
/*
	Enumeration bg = locale.getAllBranchGraphs();
    BranchGroup a = (BranchGroup)bg.nextElement();
    System.out.println( a );
    BranchGroup aa = (BranchGroup)bg.nextElement();
    System.out.println( aa );
*/
    
    String allItems[] = list.getItems();
    for(int j=0; j<allItems.length; j++)
      if(allItems[j].equals((String)evt.getItem())) {
      	System.out.println("You have already got it!!!!!");
      	return;
      }	
        
 	for(int i=0; i<Numberofappl; i++)
	  if(((String)molecules[i].get("MOLECULE_ID")).equals((String)evt.getItem())) {
           molecules[i] = createSceneGraph((String)evt.getItem());
           molecules[i].put("MOLECULE_ID", (String)evt.getItem());
		   list.add((String)evt.getItem());
           initTRS((String)evt.getItem());
           //System.out.println("HashMap: "+molecules[i].toString());
           break;
      }       
    }
   } else {
   	  System.out.println("It has the Normal Mode!!!!");
   	  return;
   }	   
  }


  public void add(Panel p, Component c, GridBagConstraints gbc,
                int x, int y, int w, int h) {
	gbc.gridx = x;
	gbc.gridy = y;
	gbc.gridwidth = w;
	gbc.gridheight = h;
	p.add(c, gbc);
  }


  public void actionPerformed(ActionEvent evt) {
    String arg = evt.getActionCommand();
    String items[] = list.getSelectedItems();

    if(arg.startsWith("Axis")) {
          	      	
      extensions.generic.AxisObject axis = (extensions.generic.AxisObject)axisData.get("axis");
      Shape3D textx = (Shape3D)axisData.get("X");
      Shape3D texty = (Shape3D)axisData.get("Y");
      Shape3D textz = (Shape3D)axisData.get("Z");

      if(arg.equals("AxisOn")) {
	  if(axis.numGeometries() == 0) {
	    axis.insertGeometry((Geometry)axisData.get("axisgeom"), 0);
	    textx.insertGeometry((Geometry)axisData.get("textxgeom"), 0);
	    texty.insertGeometry((Geometry)axisData.get("textygeom"), 0);
	    textz.insertGeometry((Geometry)axisData.get("textzgeom"), 0);
	  }
	  else System.out.println("Geometry is existed already!!!!");
      } else if(arg.equals("AxisOff")) {
	  if(axis.numGeometries() == 1){ 
	    axisData.put("axisgeom", axis.getGeometry());
	    axisData.put("textxgeom", textx.getGeometry());
	    axisData.put("textygeom", texty.getGeometry());
	    axisData.put("textzgeom", textz.getGeometry());
	  
	    axis.removeGeometry(0);
	    textx.removeGeometry(0);
	    texty.removeGeometry(0);
	    textz.removeGeometry(0);
	  }				
	  else System.out.println("Geometry is NOT existed!!!!");
       }
    } //if "Axis"
    else {

	 if(!Normal_mode) {
      if(arg.equals("Translate")) {
         label.setText("Mode: Translate");
         MODE = TRANSLATE; 

         for( int i = 0; i < items.length; i++ ){
             System.out.println("Translate item: " + items[i]);
             doTransformText(items[i]);
         }


/*
         TransformGroup tg1 = new TransformGroup();
	     setCapabilities(tg1);

         for( int i = 0; i < items.length; i++ ){	

  	      for(int j=0; j<Numberofappl; j++)
	       if(((String)molecules[j].get("MOLECULE_ID")).equals(items[i])) {
              tg1 = (TransformGroup)molecules[j].get("C");
              break;
           }                     	
		}
         Transform3D t3d1 = new Transform3D();
         tg1.getTransform( t3d1 );
         Vector3d v1 = new Vector3d();
	     t3d1.get(v1);
	     System.out.println("X: "+v1.x+"    Y: "+v1.y+"     Z: "+v1.z);
*/


      } else if(arg.equals("Rotate")) {
         label.setText("Mode: Rotate");
         MODE = ROTATE; 
         for( int i = 0; i < items.length; i++ ){
             System.out.println("Rotate item: " + items[i]);
             doTransformText(items[i]);
         }
      } else if(arg.equals("Scale")) {
         label.setText("Mode: Scale");
         MODE = SCALE;
         for( int i = 0; i < items.length; i++ ){
             System.out.println("Scale item: " + items[i]);
             doTransformText(items[i]);
         }
      }
     } else {
     	System.out.println("It has the Normal Mode!!!");
     	return;
     }	 
    }
 
  }


  public void writeCoordtoFile()
  {
     try
     {
        String filename = "MoleculeInfo"+moleculecount+".txt";
        String selectedItems[] = list.getSelectedItems();
		HashMap tmp = new HashMap();
		
	    if(selectedItems.length == 0) {
	    	System.out.println("You don't have any the selected items!!!!!!");
	    	return;
	    }	        

        FileOutputStream file = new FileOutputStream(filename);
        PrintWriter out = new PrintWriter(file);

  		for(int i=0; i<selectedItems.length; i++) {
  			
		  for(int j=0; j<molecules.length; j++)
			if(((String)molecules[j].get("MOLECULE_ID")).equals(selectedItems[i])) {
			    tmp = molecules[j];
			    break;
			}
		  
		  out.println("\n\n === "+(String)tmp.get("MOLECULE_ID")+" === \n\n");
		  out.println("\t"+"ATOM"+"\t"+"CHARGE"+"\t"+"X"+"\t\t"+"Y"+"\t\t"+"Z");
		  out.println("\t"+"---------------------------------------------------");
		  Vector writeatom = new Vector();
		  Vector writeatomcharge = new Vector();
		  
		  writeatom = (Vector)tmp.get("atom");
		  writeatomcharge = (Vector)tmp.get("atomcharge");
		  
          TransformGroup tg = new TransformGroup();
          setCapabilities(tg);		  
		  
          Transform3D t3d = new Transform3D();

		  int ncount = ((Integer)tmp.get("nvertex")).intValue();
		  double normaxis = ((Double)tmp.get("normaxis")).doubleValue();
		  Vector3d v[] = new Vector3d[ncount];
		            
     	  for(int k=0; k<ncount; k++) {
     	  	v[k] = new Vector3d();
     	  	tg = (TransformGroup)tmp.get((String)writeatom.elementAt(k));
            tg.getTransform( t3d );
            t3d.get( v[k] );
            
            out.println("\t"+(String)writeatom.elementAt(k)+
                        "\t"+((Float)writeatomcharge.elementAt(k)).floatValue()+
                        "\t"+v[k].x*normaxis+"\t"+v[k].y*normaxis+"\t"+v[k].z*normaxis);            
          }
        
        }       
        
        out.flush();
        file.close();
        moleculecount++;
        System.out.println("Write Info into File ===> Done. ");
     }
     catch(IOException ex)
     {
         System.err.println("Can't write to `" +  ex.getMessage() + "'");
         //System.exit(1);
     }
  }

  private void canvasXYMousePressed (MouseEvent evt) {
    System.out.println( "pressed X: " + evt.getX() + " Y: " + evt.getY() );
    lastX = evt.getX();
    lastY = evt.getY();
  }

  private void canvasXYMouseDragged (MouseEvent evt) {
    System.out.print( "dX: ");
    System.out.print( evt.getX() - lastX );
    System.out.print( " dY: ");
    System.out.print( evt.getY() - lastY );
    System.out.println();
    String items[] = list.getSelectedItems();
    for( int i = 0; i < items.length; i++ ){
      System.out.println("item: " + items[i]);
      doTransform(evt.getX() - lastX, evt.getY() - lastY, items[i]);
    }

    lastX = evt.getX();
    lastY = evt.getY();
  }

  /** This method creates and returns a BranchGroup with a view platform.
   * canvas is the Canvas3D object
   */
  public BranchGroup createViewplatformGraph(Canvas3D canvas){
    TransformGroup vpTrans;
    View view;
    BranchGroup vpRoot;
    ViewPlatform vp;
    PhysicalBody body = new PhysicalBody();
    PhysicalEnvironment environment = new PhysicalEnvironment();

    view = new View();
    view.addCanvas3D( canvas );
    view.setPhysicalBody( body );
    view.setPhysicalEnvironment( environment );

    vpRoot = new BranchGroup();
    vpRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );

    Vector3d up = null;
    Point3d center, v;
    Transform3D t = new Transform3D();
    t.set( new Vector3f( 0.0f, 0.0f, 4.0f ) ); //set the vp location to the viewLocation

    vp = new ViewPlatform();
    vpTrans = new TransformGroup(t);

    vpTrans.addChild( vp );
    vpRoot.addChild( vpTrans );

    view.attachViewPlatform( vp );
    return vpRoot;
  }
   
  public void initTRS(String name) {

     TransformGroup trs = new TransformGroup();
  	 
  	 for(int i=0; i<Numberofappl; i++) {
  	   //System.out.println("initTRS: "+(String)molecules[i].get("MOLECULE_ID"));
	   if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
		  trs = (TransformGroup)molecules[i].get(name);
		  break;
       }
     }

      Transform3D t3d = new Transform3D();
      trs.getTransform( t3d );

      Vector3d v = new Vector3d();
      t3d.get( v );
      transX.setText(String.valueOf(v.x));
      transY.setText(String.valueOf(v.y));      
	  transZ.setText(String.valueOf(v.z));

      Matrix4d m = new Matrix4d();
      Vector3d axis = new Vector3d();
      AxisAngle4d aa = new AxisAngle4d();
      double newangle;
      axis.set( 0.0d, 0.0d, 1.0d );            
      t3d.get( m );
      aa.set( m );
      newangle =  (double) aa.angle;
      rotangle.setText(String.valueOf(newangle));
      plane = XY;
      rotxy.setState(true);

      double scalenum = t3d.getScale();
      scaleX.setText(String.valueOf(scalenum));
  }


  public void setCapabilities(TransformGroup tg) 
  {
     tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
     tg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
     tg.setCapability(Group.ALLOW_CHILDREN_WRITE);
     tg.setCapability(Group.ALLOW_CHILDREN_READ);
     tg.setCapability(Group.ALLOW_CHILDREN_EXTEND);
     tg.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
  } 


  public void doTransform(int dx, int dy, String name){

     //TransformGroup tg = new TransformGroup();
     //setCapabilities(tg);
     //HashMap molecule_tmp = new HashMap();

     if( name == null )
       return;

  	  for(int i=0; i<Numberofappl; i++)
	    if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
           doTranstg = (TransformGroup)molecules[i].get(name);
           doTranstmp = molecules[i];
           //System.out.println("doTransform: "+(String)molecules[i].toString());
           break;
        }     
	 
	 int mnvertex = ((Integer)doTranstmp.get("nvertex")).intValue();
	 int mcylindercount = ((Integer)doTranstmp.get("cylindercount")).intValue();
     int totaltg = mnvertex + mcylindercount; //+4;

     //System.out.println("TotalTG: "+totaltg);
     //TransformGroup tgarray[] = new TransformGroup[totaltg];

     //Transform3D t3d = new Transform3D();
     //Transform3D t3darray[] = new Transform3D[totaltg];

     /*
     for(int i = 0; i<totaltg; i++) {
        tgarray[i] = new TransformGroup();
        setCapabilities(tgarray[i]);
     } 
     */  

	 Vector atomsofmolecule = new Vector();
	 atomsofmolecule = (Vector)doTranstmp.get("atom");
	 int numofatom = atomsofmolecule.size();
	 for(int i=0; i<numofatom; i++) {
	    doTranstgarray[i] = (TransformGroup)doTranstmp.get((String)atomsofmolecule.elementAt(i));
        //System.out.println("doTransform1: "+(String)atomsofmolecule.elementAt(i));
     }
     
     for(int i = 1; i<=mcylindercount; i++) {
         String tmp = "Cylindername"+i;
	     doTranstgarray[i+numofatom-1] = (TransformGroup)doTranstmp.get(tmp);
     }

/*
	 int arrayindex = numofatom+mcylindercount;
     tgarray[arrayindex] = (TransformGroup)molecule_tmp.get("axisTG");
     tgarray[arrayindex+1] = (TransformGroup)molecule_tmp.get("XTG");
     tgarray[arrayindex+2] = (TransformGroup)molecule_tmp.get("YTG");
     tgarray[arrayindex+3] = (TransformGroup)molecule_tmp.get("ZTG");
*/

     doTranstg.getTransform( doTranst3d );
     for(int j=0; j<totaltg; j++) {
          //t3darray[j] = new Transform3D();
          doTranstgarray[j].getTransform( doTranst3darray[j] );
		  //System.out.println("t3dARRAY[M"+j+"] = "+t3darray[j]);
     }

     //System.out.println( "transforming shape: " + name );

     //double TRANSLATE_SCALE = 100.0d;
     switch(MODE){
      case TRANSLATE:
           	//Vector3d v = new Vector3d();
            //Vector3d varray[] = new Vector3d[totaltg];

//        switch(plane){
//          case XY:

            doTranst3d.get( doTransv );
	        for(int k=0; k<totaltg; k++) {
                 //varray[k] = new Vector3d();
	             doTranst3darray[k].get( doTransvarray[k] );
		         //System.out.println("t3dARRAY["+k+"] = "+t3darray[k]);
            }

	        transX.setText(String.valueOf(doTransv.x));
	        transY.setText(String.valueOf(doTransv.y));
            transZ.setText(String.valueOf(doTransv.z));
            
            doTransvv.set( doTransv.x + (double)dx / 100.0d, doTransv.y - (double)dy / 100.0d, doTransv.z );
            doTranst3d.setTranslation( doTransvv );

	        for(int l=0; l<totaltg; l++) {
	           doTransvvarray[l].set( doTransvarray[l].x + (double)dx / 100.0d,
	                 doTransvarray[l].y - (double)dy / 100.0d, doTransvarray[l].z );
	           	
               doTranst3darray[l].setTranslation( doTransvvarray[l] );
            }

/*
          break;
          case XZ:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x + (float)dx / TRANSLATE_SCALE, v.y, v.z - (float)dy / TRANSLATE_SCALE ) );
          break;
          case YZ:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x, v.y + (float)dx / TRANSLATE_SCALE, v.z - (float)dy / TRANSLATE_SCALE) );
          break;
        }
*/

      break;
      case ROTATE:
        //Matrix4d m = new Matrix4d();
        //Matrix4d marray[] = new Matrix4d[totaltg];
        //Vector3d vv = new Vector3d();
        //Vector3d vvarray[] = new Vector3d[totaltg];
        
        //Vector3d axis = new Vector3d();
        
        //AxisAngle4d aa = new AxisAngle4d();
        //AxisAngle4d aaarray[] = new AxisAngle4d[totaltg];
        
        double newangle;
        //double newanglearray[] = new double[totaltg];

        /*
        t3d.get( vv );
	    for(int k=0; k<totaltg; k++) {
           vvarray[k] = new Vector3d();
	       t3darray[k].get( vvarray[k] );
		   System.out.println("vvarray["+k+"] = "+vvarray[k]);
        }
		   System.out.println("t3d: = "+t3d);
        */
        switch(plane){
          case XY:
            doTransaxis.set( 0.0d, 0.0d, 1.0d );
            
            doTranst3d.get( doTransm );
            doTransaa.set( doTransm ); 
            /*
			System.out.println("m = "+ m);
		    System.out.println("aa = "+aa);                 
            for(int k=0; k<totaltg; k++) {
                 marray[k] = new Matrix4d();
                 aaarray[k] = new AxisAngle4d();
	             t3darray[k].get( marray[k] );
	             aaarray[k].set( marray[k] );
	             System.out.println("marray["+k+"] = "+marray[k]);
	             System.out.println("aaarray["+k+"] = "+aaarray[k]);
            }
            */
                                     
            newangle = (double) doTransaa.angle + (double)Math.toRadians((double)dy/10.0d);
	        //System.out.println("AA: "+aa.angle);	        
	       
	       /*
	        for(int k=0; k<totaltg; k++) {
	        	newanglearray[k] = (double)aaarray[k].angle
	        	            + (double)Math.toRadians((double)dy);
	        	marray[k].rotZ(newangle);            
	        	System.out.println("marray[R"+k+"] = "+ marray[k]);
	        }
			*/

			
            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle <= 0.0d ){
              newangle = (double)Math.PI;
            }

		    /*
			double xx, yy;
			double xxarray[] = new double[totaltg];
			double yyarray[] = new double[totaltg];
			
			xx = vv.x*Math.cos(newangle) + vv.y*Math.sin(newangle) + 0.0d;
			yy = vv.x*(-Math.sin(newangle)) + vv.y*Math.cos(newangle) + 0.0d;			
			vv.x = vv.x + xx;
			vv.y = vv.y + yy;

		    for(int i=0; i<totaltg; i++) {
		    	xxarray[i] = vvarray[i].x*Math.cos(newangle) + vvarray[i].y*Math.sin(newangle) + 0.0d;
		    	yyarray[i] = vvarray[i].x*(-Math.sin(newangle)) + vvarray[i].y*Math.cos(newangle) + 0.0d;
		    	vvarray[i].x = vvarray[i].x + xxarray[i];
		    	vvarray[i].y = vvarray[i].y + yyarray[i];
		    }	


            t3d.setTranslation( 
              new Vector3d( vv.x, vv.y, vv.z) );

	        for(int l=0; l<mnvertex; l++)
               t3darray[l].setTranslation( 
                   new Vector3d( vvarray[l].x, vvarray[l].y, vvarray[l].z) );
			*/

			//t3d.rotZ(newangle);
		    //System.out.println("t3d: = "+t3d);

	        //for(int k=0; k<totaltg; k++) {
               //t3darray[k].rotZ(newangle);			
 		       //System.out.println("t3dARRAY[After"+k+"] = "+t3darray[k]);
 		    //}         
            /*
            for(int k=0; k<totaltg; k++)
               if( newanglearray[k] > Math.PI ){
                     newanglearray[k] = 0.0d;
               } else if ( newanglearray[k] <= 0.0d ){
                     newanglearray[k] = (double)Math.PI;
               }
            */         
                                    
            System.out.println("angle: " + newangle );
	        rotangle.setText(String.valueOf(newangle));
	        //for(int k=0; k<totaltg; k++)
	          //System.out.println("newangle["+k+"] = "+newanglearray[k]);
            doTransaa.set( doTransaxis.x, doTransaxis.y, doTransaxis.z, newangle );
            //for(int k=0; k<totaltg; k++)
               //aaarray[k].set( axis.x, axis.y, axis.z, newanglearray[k] );
            
            doTranst3d.setRotation( doTransaa );
            //for(int k=0; k<totaltg; k++)
               //t3darray[k].setRotation( marray[k] );           
			   //t3darray[k].rotZ( newangle );
          break;
          case XZ:
            doTransaxis.set( 0.0d, 1.0d, 0.0d );

            doTranst3d.get( doTransm );
            doTransaa.set( doTransm );

            newangle =  (double) doTransaa.angle + (double)Math.toRadians((double)dy/10.0d);

            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle <= 0.0d ){
              newangle = (double)Math.PI;
            }

            System.out.println("angle: " + newangle );
	        rotangle.setText(String.valueOf(newangle));

            doTransaa.set( doTransaxis.x, doTransaxis.y, doTransaxis.z, newangle );
            doTranst3d.setRotation( doTransaa );
            
            break;
            
          case YZ:
            doTransaxis.set( 1.0d, 0.0d, 0.0d );

            doTranst3d.get( doTransm );
            doTransaa.set( doTransm );

            newangle =  (double) doTransaa.angle + (double)Math.toRadians((double)dy/10.0d);

            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle <= 0.0d ){
              newangle = (double)Math.PI;
            }

            System.out.println("angle: " + newangle );
            doTransaa.set( doTransaxis.x, doTransaxis.y, doTransaxis.z, newangle );
	        rotangle.setText(String.valueOf(newangle));

            doTranst3d.setRotation( doTransaa );
            break;
        }
      break;
      
      case SCALE:
	    	    
	    double scalelevel = doTranst3d.getScale();	
	    //double scalelevelarray[] = new double[totaltg];

	    //for(int i=0; i<totaltg; i++) 
	        //scalelevelarray[i] = t3darray[i].getScale();
	    
	    doTranst3d.setScale(scalelevel + ((double)dy)/100.0d);
	    /*
	    for( int i=0; i<totaltg; i++) {
	       t3darray[i].setScale(scalelevelarray[i] + ((double)dy)/100.0d);
	       System.out.println("Scale T3d["+i+"] = "+ t3darray[i]);	        
	    }
	    */
	    	        
	    scaleX.setText(String.valueOf(scalelevel + ((double)dy)/100.0d));
	    	    	    	    
      break;
    }

    //System.out.println("doTranst3d: " + doTranst3d); 
    doTranstg.setTransform( doTranst3d );

    if(MODE == TRANSLATE)
      for(int m=0; m<totaltg; m++)
          doTranstgarray[m].setTransform( doTranst3darray[m] );
  }

  public void doTransformText(String name){

     TransformGroup tg = new TransformGroup();
     setCapabilities(tg);
     HashMap molecule_tmp = new HashMap();

     if( name == null )
       return;

  	  for(int i=0; i<Numberofappl; i++)
	    if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
           tg = (TransformGroup)molecules[i].get(name);
           molecule_tmp = molecules[i];
           break;
        }     

	 int mnvertex = ((Integer)molecule_tmp.get("nvertex")).intValue();
	 int mcylindercount = ((Integer)molecule_tmp.get("cylindercount")).intValue();
	 
     int totaltg = mnvertex + mcylindercount; //+4;
     TransformGroup tgarray[] = new TransformGroup[totaltg];

     Transform3D t3d = new Transform3D();
     Transform3D t3darray[] = new Transform3D[totaltg];

     for(int i = 0; i<totaltg; i++) {
        tgarray[i] = new TransformGroup();
        setCapabilities(tgarray[i]);
     }   

	 Vector atomsofmolecule = new Vector();
	 atomsofmolecule = (Vector)molecule_tmp.get("atom");
	 int numofatom = atomsofmolecule.size();
	 for(int i=0; i<numofatom; i++)
	    tgarray[i] = (TransformGroup)molecule_tmp.get((String)atomsofmolecule.elementAt(i));

     for(int i = 1; i<=mcylindercount; i++) {
         String tmp = "Cylindername"+i;
	     tgarray[i+numofatom-1] = (TransformGroup)molecule_tmp.get(tmp);
     }

/*
	 int arrayindex = numofatom+mcylindercount;
     tgarray[arrayindex] = (TransformGroup)molecule_tmp.get("axisTG");
     tgarray[arrayindex+1] = (TransformGroup)molecule_tmp.get("XTG");
     tgarray[arrayindex+2] = (TransformGroup)molecule_tmp.get("YTG");
     tgarray[arrayindex+3] = (TransformGroup)molecule_tmp.get("ZTG");
*/

     tg.getTransform( t3d );
     for(int j=0; j<totaltg; j++) {
          t3darray[j] = new Transform3D();
          tgarray[j].getTransform( t3darray[j] );
     }

     //System.out.println( "transforming shape: " + name );

     double TRANSLATE_SCALE = 100.0d;
     switch(MODE){
      case TRANSLATE:

           	Vector3d v = new Vector3d();
           	//double vdistancex = 0.0;
           	//double vdistancey = 0.0;
           	//double vdistancez = 0.0;           	
           	
            Vector3d varray[] = new Vector3d[totaltg];
		    //double vdistancearrayx[] = new double[totaltg];
		    //double vdistancearrayy[] = new double[totaltg];
		    //double vdistancearrayz[] = new double[totaltg];		    
//        switch(plane){
//          case XY:

            t3d.get( v );
			//vdistancex = Math.abs(v.x - Double.parseDouble(transX.getText().trim()));
		    //vdistancey = Math.abs(v.y - Double.parseDouble(transY.getText().trim()));		
			//vdistancez = Math.abs(v.z - Double.parseDouble(transZ.getText().trim()));

	        for(int k=0; k<totaltg; k++) {
                 varray[k] = new Vector3d();
	             t3darray[k].get( varray[k] );
            }
            
            /*
            for(int k=0; k<totaltg; k++) {
            	vdistancearrayx[k] = Math.abs(varray[k].x - Double.parseDouble(transX.getText().trim()));
                vdistancearrayy[k] = Math.abs(varray[k].y - Double.parseDouble(transY.getText().trim()));
               	vdistancearrayz[k] = Math.abs(varray[k].z - Double.parseDouble(transZ.getText().trim()));                    	 
		    }  
		    */

            t3d.setTranslation( 
              new Vector3d(v.x + Double.parseDouble(transX.getText().trim()),
                           v.y + Double.parseDouble(transY.getText().trim()),
              	           v.z + Double.parseDouble(transZ.getText().trim())));


	    for(int l=0; l<totaltg; l++)
          t3darray[l].setTranslation( 
             new Vector3d( varray[l].x + Double.parseDouble(transX.getText().trim()),
                           varray[l].y + Double.parseDouble(transY.getText().trim()),
                 	       varray[l].z + Double.parseDouble(transZ.getText().trim())));
        break;
      case ROTATE:
        Matrix4d m = new Matrix4d();
        Vector3d axis = new Vector3d();
        AxisAngle4d aa = new AxisAngle4d();
        double newangle;

        switch(plane){
          case XY:
            axis.set( 0.0d, 0.0d, 1.0d );
            
            t3d.get( m );
            aa.set( m );

            newangle =  Double.parseDouble(rotangle.getText().trim());

            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle <= 0.0d ){
              newangle = (double)Math.PI;
            }
            aa.set( axis.x, axis.y, axis.z, newangle );
            t3d.setRotation( aa );

          break;
          case XZ:
            axis.set( 0.0d, 1.0d, 0.0d );

            t3d.get( m );
            aa.set( m );

            newangle = Double.parseDouble(rotangle.getText().trim());

            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle <= 0.0d ){
              newangle = (double)Math.PI;
            }
            aa.set( axis.x, axis.y, axis.z, newangle );
            t3d.setRotation( aa );
            
            break;
            
          case YZ:
            axis.set( 1.0d, 0.0d, 0.0d );

            t3d.get( m );
            aa.set( m );

            newangle = Double.parseDouble(rotangle.getText().trim());

            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle <= 0.0d ){
              newangle = (double)Math.PI;
            }

            aa.set( axis.x, axis.y, axis.z, newangle );
            t3d.setRotation( aa );
            break;
        }
      break;
      case SCALE:	
	    t3d.setScale(Double.parseDouble(scaleX.getText().trim()));
        break;
    }

    //System.out.println("t3d: " + t3d); 
    tg.setTransform( t3d );
    for(int m=0; m<totaltg; m++)
        tgarray[m].setTransform( t3darray[m] );

  }
  
  
  public HashMap createSceneGraph(String targetgeomName) {

      HashMap moleculedata = new HashMap();
      BranchGroup rootBG = new BranchGroup();

//      Transform3D t3D = new Transform3D();
//      t3D.setScale(0.5f);

      Transform3D t3D1 = new Transform3D();
      t3D1.rotX(0.1f);

      Transform3D t3D2 = new Transform3D();	
      t3D2.rotY(-0.25f);

      t3D1.mul(t3D2);
//      t3D.mul(t3D1);

      TransformGroup sceneTG = new TransformGroup(t3D1);
      setCapabilities(sceneTG);

      moleculedata.put(targetgeomName,sceneTG);

      BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
      //BoundingSphere bounds1 = new BoundingSphere();

    
/*
      // Add mouse behaviors
      // Create the rotate behavior node
      MouseRotate rotBehavior = new MouseRotate();
      rotBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(rotBehavior);
      rotBehavior.setSchedulingBounds(bounds);
      
      // Create the zoom behavior node
      MouseZoom zoomBehavior = new MouseZoom();
      zoomBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(zoomBehavior);
      zoomBehavior.setSchedulingBounds(bounds);
      
      // Create the translate behavior node
      MouseTranslate transBehavior = new MouseTranslate();
      transBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(transBehavior);
      transBehavior.setSchedulingBounds(bounds);
*/

/*      
      //add Axis
      TransformGroup axisTG = new TransformGroup();
	  setCapabilities(axisTG);

      extensions.generic.AxisObject axis = new extensions.generic.AxisObject();

      axisTG.addChild(axis);
      sceneTG.addChild(axisTG);
      moleculedata.put("axis", axis);
      moleculedata.put("axisTG", axisTG);

      //hashTransformgroup.put("axis", axis);

      //add the coordinate axis
      // Create a simple Text2D leaf node, add it to the scene graph.
      //X-axis
      Vector3f xposition = new Vector3f(1.0f,0.0f,0.0f);
      renderobject3d.setText2DRender("X", xposition, sceneTG);

      //Y-axis
      Vector3f yposition = new Vector3f(0.0f,1.0f,0.0f);
      renderobject3d.setText2DRender("Y", yposition, sceneTG);

      //Z-axis
      Vector3f zposition = new Vector3f(0.0f,0.0f,1.0f);
      renderobject3d.setText2DRender("Z", zposition, sceneTG);

      moleculedata.put("X", renderobject3d.hashShape3d.get("X"));
      moleculedata.put("Y", renderobject3d.hashShape3d.get("Y"));
      moleculedata.put("Z", renderobject3d.hashShape3d.get("Z"));
      moleculedata.put("XTG", renderobject3d.hashShape3d.get("XTG"));
      moleculedata.put("YTG", renderobject3d.hashShape3d.get("YTG"));
      moleculedata.put("ZTG", renderobject3d.hashShape3d.get("ZTG"));
*/
     
      //getting data from XML file to render some objects
      Vector geometries = parsexmllist.getParseXMLgeometries();
      Vector geometryName = parsexmllist.getParseXMLgeometriesName();

      int targetIndex = 0;

      for (int i = 0; i < geometryName.size(); i++) {
	  String tmp = (String)geometryName.elementAt(i);
	  if(tmp.equals(targetgeomName)) {
			targetIndex = i;
			break;
	  }
      }

      plot3d = (extensions.generic.Plot3D)geometries.elementAt(targetIndex);

      int nvertex = plot3d.getNvertex();
      moleculedata.put("nvertex", new Integer(nvertex));
	  System.out.println("Processing geometry " + (targetIndex+1) + ": vertices = " + nvertex);

	  if(nvertex == 0 || plot3d.getCoordXList() == null){
	      System.out.println("Bad Java3DGeometry");
	      //continue;
	  }

	  double[][] coorddata = new double[nvertex][3];
	  double[][] orgcoorddata = new double[nvertex][3];

	  String geomtype = plot3d.getJava3DGeometryType();
	  String coordunit = plot3d.getCoordUnit();
	  
	  String[] atom = plot3d.getAtomList();
	  Vector atomvector = new Vector();
	  for(int i=0; i<atom.length; i++)
	  	   atomvector.addElement(atom[i]);
	  moleculedata.put("atom", atomvector);

	  Vector atomchargevector = new Vector();
	  float[] atomcharge = plot3d.getAtomicChargeList();
	  for(int i=0; i<atomcharge.length; i++)
	       atomchargevector.addElement(new Float(atomcharge[i]));

	  moleculedata.put("atomcharge", atomchargevector);

	  double[] coordx = plot3d.getCoordXList();
	  double[] coordy = plot3d.getCoordYList();
	  double[] coordz = plot3d.getCoordZList();
	  float[] colors = plot3d.getColors();

	  for(int l=0; l<nvertex; l++) {
	     orgcoorddata[l][0] = coordx[l];	
	     orgcoorddata[l][1] = coordy[l];	    
	     orgcoorddata[l][2] = coordz[l];
	  }

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)	
	    System.out.println(orgcoorddata[l][m]);
	  
	  double maxs = coorddata[0][0];
	  double mins = coorddata[0][0];
	  double absmaxs;
	  double absmins;
	  double normalizedValue;
	  double normalizedAxis = 0.0;

	  for(int l=1; l<nvertex; l++) {
	   for(int m=0; m<3; m++) {
	      if(orgcoorddata[l][m] > maxs) maxs = orgcoorddata[l][m];
	      if(orgcoorddata[l][m] < mins) mins = orgcoorddata[l][m];
	   }
	  }
	  System.out.println("Maxs = "+maxs);
	  System.out.println("Mins = "+mins);	

	  System.out.println("Geometry Type: "+geomtype);

	  if( maxs < -1.0 || maxs > 1.0 || mins < -1.0 || mins > 1.0) {
	    if(maxs < -1.0 || maxs > 1.0) {
		 absmaxs = Math.abs(maxs);
		 if(mins < -1.0 || mins > 1.0) {
			absmins = Math.abs(mins);
			normalizedValue = Math.max(absmaxs, absmins);
			normalizedAxis = Math.ceil(normalizedValue);
		 }
		 else normalizedAxis = Math.ceil(absmaxs);
	    }
	    else {
		absmins = Math.abs(mins);
		normalizedAxis = Math.ceil(absmins);
	    }
	    for(int l=0; l<nvertex; l++)
	     for(int m=0; m<3; m++) {
	    	double tmp = orgcoorddata[l][m] / normalizedAxis;
		coorddata[l][m] = tmp;
	     }
	  }
	  else {
	     for(int l=0; l<nvertex; l++)
	      for(int m=0; m<3; m++)
		coorddata[l][m] = orgcoorddata[l][m];
	  }		


	  moleculedata.put("normaxis", new Double(normalizedAxis));

	  int k=0;
	  
	  for (int l=0; l<nvertex; l++) {	
	  double[] atomaxis = {coorddata[l][0], coorddata[l][1], coorddata[l][2]};      
	  Color3f atomAppearcolor = new Color3f(colors[k+l], colors[k+1+l], colors[k+2+l]);

	  //each Object is rendering. carbon, hydrogens.
	  if(geomtype.equals("Sphere")) {

		double satomchargef = Math.sqrt((double)atomcharge[l]);
        float atomradius = ((float)satomchargef)/10.0f;
      		
        Vector3d atomposition = new Vector3d(atomaxis[0], atomaxis[1], atomaxis[2]);
        renderobject3d.setSphereRender(atomradius,atomAppearcolor,atomposition,sceneTG);
		moleculedata.put(atom[l], (TransformGroup)renderobject3d.hashShape3d.get("Sphere"));
       	               		
	  }
	  k = k+2;
	  }

	  //rendering bars for the bonds between the carbon and hydrogen atoms

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)
	     System.out.println(coorddata[l][m]); 
	
	  int n=0;
	  int cylindercount = 0;
	  for(int l=0; l<nvertex - 1; l++) {  //nvertex - 1;
	   for(int m=n+1; m<nvertex; m++) {
	     System.out.println("m = "+m);
	     double bondCheck = renderobject3d.getLength(orgcoorddata[l], orgcoorddata[m]);
	     System.out.println("BondCheck = "+bondCheck);
	     //1.5 Angstroms = 2.834Bohr 
	     if(((bondCheck < 2.834467) && (coordunit.equals("BOHR")))
	         || ((bondCheck < 1.50000) && (coordunit.equals("Angstroms"))) ) {

	       float cylinderradius = 0.025f;
               Color3f cylinderAppearcolor = new Color3f(0.9f, 0.1f, 0.0f);

	       renderobject3d.renderingBar(cylinderradius,cylinderAppearcolor,coorddata[l],coorddata[m],sceneTG);
	       cylindercount++;
	       System.out.println("Cylindercount: "+cylindercount);
	       String cylindername = "Cylindername"+cylindercount;
	       moleculedata.put(cylindername, (TransformGroup)renderobject3d.hashShape3d.get("Cylinder"));
	     }	
	   }
	   ++n;
	 }

     moleculedata.put("cylindercount", new Integer(cylindercount));
     
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      rootBG.setCapability( BranchGroup.ALLOW_DETACH );

      rootBG.addChild(sceneTG);

/*
      PickRotateBehavior pickRotate = new PickRotateBehavior(rootBG, canvasXYZ, bounds);
	  rootBG.addChild(pickRotate); 
      PickingCallback identityCallback = new IdentityCallback();
      // Register the class callback to be called 
      pickRotate.setupCallback(identityCallback);
*/
      //rootBG.compile();
      locale.addBranchGraph( rootBG );

      moleculedata.put(targetgeomName+"BG",rootBG);
      return moleculedata;
  }


  public HashMap createSceneGraphAnimation (float[][] modes) {

      HashMap moleculedata = new HashMap();
      BranchGroup rootBG = new BranchGroup();

      Transform3D t3D1 = new Transform3D();
      t3D1.rotX(0.1f);

      Transform3D t3D2 = new Transform3D();	
      t3D2.rotY(-0.25f);

      t3D1.mul(t3D2);
      
      TransformGroup sceneTG = new TransformGroup(t3D1);
      setCapabilities(sceneTG);

      //moleculedata.put(targetgeomName,sceneTG);

      BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
      //BoundingSphere bounds1 = new BoundingSphere();

      // Add mouse behaviors
      // Create the rotate behavior node
      MouseRotate rotBehavior = new MouseRotate();
      rotBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(rotBehavior);
      rotBehavior.setSchedulingBounds(bounds);
         
      // Create the zoom behavior node
      MouseZoom zoomBehavior = new MouseZoom();
      zoomBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(zoomBehavior);
      zoomBehavior.setSchedulingBounds(bounds);
      
      // Create the translate behavior node
      MouseTranslate transBehavior = new MouseTranslate();
      transBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(transBehavior);
      transBehavior.setSchedulingBounds(bounds);

      //getting data from XML file to render some objects
      Vector geometries = parsexmllist.getParseXMLgeometries();
      Vector geometryName = parsexmllist.getParseXMLgeometriesName();

      int targetIndex = 0;

      for (int i = 0; i < geometryName.size(); i++) {
	  String tmp = (String)geometryName.elementAt(i);
	  if(tmp.equals("3DGeometry4")) {
			targetIndex = i;
			break;
	  }
      }

      plot3d = (extensions.generic.Plot3D)geometries.elementAt(targetIndex);

      int nvertex = plot3d.getNvertex();
      //moleculedata.put("nvertex", new Integer(nvertex));
	  System.out.println("Processing geometry " + (targetIndex+1) + ": vertices = " + nvertex);

	  if(nvertex == 0 || plot3d.getCoordXList() == null){
	      System.out.println("Bad Java3DGeometry");
	      //continue;
	  }

	  double[][] coorddata = new double[nvertex][3];
	  double[][] orgcoorddata = new double[nvertex][3];

	  String geomtype = plot3d.getJava3DGeometryType();
	  String coordunit = plot3d.getCoordUnit();

	  String[] atom = plot3d.getAtomList();

	  //moleculedata.put("atom", atom);

	  float[] atomcharge = plot3d.getAtomicChargeList();

	  //moleculedata.put("atomcharge", atomcharge);

	  double[] coordx = plot3d.getCoordXList();
	  double[] coordy = plot3d.getCoordYList();
	  double[] coordz = plot3d.getCoordZList();
	  float[] colors = plot3d.getColors();

	  for(int l=0; l<nvertex; l++) {
	     orgcoorddata[l][0] = coordx[l];
	     orgcoorddata[l][1] = coordy[l];
	     orgcoorddata[l][2] = coordz[l];
	  }

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)	
	    System.out.println(orgcoorddata[l][m]);
	  
	  double maxs = coorddata[0][0];
	  double mins = coorddata[0][0];
	  double absmaxs;
	  double absmins;
	  double normalizedValue;
	  double normalizedAxis = 0.0;
	  float[][] normMode = new float[7][3];
	  double tmp;
	  float tmp1;

	  for(int l=1; l<nvertex; l++) {
	   for(int m=0; m<3; m++) {
	      if(orgcoorddata[l][m] > maxs) maxs = orgcoorddata[l][m];
	      if(orgcoorddata[l][m] < mins) mins = orgcoorddata[l][m];
	   }
	  }
	  System.out.println("Maxs = "+maxs);
	  System.out.println("Mins = "+mins);	

	  System.out.println("Geometry Type: "+geomtype);

	  if( maxs < -1.0 || maxs > 1.0 || mins < -1.0 || mins > 1.0) {
	    if(maxs < -1.0 || maxs > 1.0) {
		 absmaxs = Math.abs(maxs);
		 if(mins < -1.0 || mins > 1.0) {
			absmins = Math.abs(mins);
			normalizedValue = Math.max(absmaxs, absmins);
			normalizedAxis = Math.ceil(normalizedValue);
		 }
		 else normalizedAxis = Math.ceil(absmaxs);
	    }
	    else {
		absmins = Math.abs(mins);
		normalizedAxis = Math.ceil(absmins);
	    }
	    for(int l=0; l<nvertex; l++)
	     for(int m=0; m<3; m++) {
	    	tmp = orgcoorddata[l][m] / normalizedAxis;
		    coorddata[l][m] = tmp;
		    //Mode Value is normalized
		    tmp1 = modes[l][m] / (float)normalizedAxis;
		    //normMode[l][m] = tmp1;
		    //Normal mode Position Figuring out
		    normMode[l][m] = (float)tmp + tmp1;
	     }
	  }
	  else {
	     for(int l=0; l<nvertex; l++)
	      for(int m=0; m<3; m++) {
		       coorddata[l][m] = orgcoorddata[l][m];
		       normMode[l][m] = (float)orgcoorddata[l][m] + modes[l][m];
		  }     
	  }		
	  	  
	  //moleculedata.put("normaxis", new Double(normalizedAxis));

	  int k=0;

	  for (int l=0; l<nvertex; l++) {
	
	  double[] atomaxis = {coorddata[l][0], coorddata[l][1], coorddata[l][2]};      
	  float[] normalPos = {normMode[l][0], normMode[l][1], normMode[l][2]};
	  
	  Color3f atomAppearcolor = new Color3f(colors[k+l], colors[k+1+l], colors[k+2+l]);

	  //each Object is rendering. carbon, hydrogens.
	  if(geomtype.equals("Sphere")) {

		double satomchargef = Math.sqrt((double)atomcharge[l]);
        float atomradius = ((float)satomchargef)/20.0f;

        //Vector3d atomposition = new Vector3d(atomaxis[0], atomaxis[1], atomaxis[2]);
        renderobject3d.setSphereRenderAnimation(atomradius,atomAppearcolor,atomaxis,
                                       normalPos,sceneTG, rootBG);
		//moleculedata.put(atomname, (TransformGroup)renderobject3d.hashShape3d.get("Sphere"));
       	               		
	  }
	  k = k+2;
	  }

	  //rendering bars for the bonds between the carbon and hydrogen atoms

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)
	     System.out.println(coorddata[l][m]); 
	
	  int n=0;
	  int cylindercount = 0;
	  for(int l=0; l<nvertex - 1; l++) {  //nvertex - 1;
	   for(int m=n+1; m<nvertex; m++) {
	     System.out.println("m = "+m);
	     double bondCheck = renderobject3d.getLength(orgcoorddata[l], orgcoorddata[m]);
	     System.out.println("BondCheck = "+bondCheck);
	     //1.5 Angstroms = 2.834Bohr 
	     if(((bondCheck < 2.834467) && (coordunit.equals("BOHR")))
	         || ((bondCheck < 1.50000) && (coordunit.equals("Angstroms"))) ) {

	       float cylinderradius = 0.025f;
               Color3f cylinderAppearcolor = new Color3f(0.9f, 0.1f, 0.0f);

	       renderobject3d.renderingBar(cylinderradius,cylinderAppearcolor,coorddata[l],coorddata[m],sceneTG);
	       cylindercount++;
	       System.out.println("Cylindercount: "+cylindercount);
	       String cylindername = "Cylindername"+cylindercount;
	       //moleculedata.put(cylindername, (TransformGroup)renderobject3d.hashShape3d.get("Cylinder"));
	     }	
	   }
	   ++n;
	 }

     //moleculedata.put("cylindercount", new Integer(cylindercount));
     
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      rootBG.setCapability( BranchGroup.ALLOW_DETACH );

      rootBG.addChild(sceneTG);

/*
      PickRotateBehavior pickRotate = new PickRotateBehavior(rootBG, canvasXYZ, bounds);
	  rootBG.addChild(pickRotate); 
      PickingCallback identityCallback = new IdentityCallback();
      // Register the class callback to be called 
      pickRotate.setupCallback(identityCallback);
*/
      //rootBG.compile();
      locale.addBranchGraph( rootBG );

      moleculedata.put("3DGeometry4BG",rootBG);
      return moleculedata;
  }

  public HashMap createAxis() {

      HashMap moleculedata = new HashMap();

      Transform3D t3D1 = new Transform3D();
      t3D1.rotX(0.1f);

      Transform3D t3D2 = new Transform3D();	
      t3D2.rotY(-0.25f);

      t3D1.mul(t3D2);

      TransformGroup axisallTG = new TransformGroup(t3D1);
      setCapabilities(axisallTG);

      moleculedata.put("axisallTG",axisallTG);

      //BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
      
      //add Axis
      TransformGroup axisTG = new TransformGroup();
	  setCapabilities(axisTG);

      extensions.generic.AxisObject axis = new extensions.generic.AxisObject();

      axisTG.addChild(axis);
      axisallTG.addChild(axisTG);
      moleculedata.put("axis", axis);
      moleculedata.put("axisTG", axisTG);

      //hashTransformgroup.put("axis", axis);

      //add the coordinate axis
      // Create a simple Text2D leaf node, add it to the scene graph.
      //X-axis
      Vector3f xposition = new Vector3f(1.4f,0.0f,0.0f);
      renderobject3d.setText2DRender("X", xposition, axisallTG);

      //Y-axis
      Vector3f yposition = new Vector3f(0.0f,1.4f,0.0f);
      renderobject3d.setText2DRender("Y", yposition, axisallTG);

      //Z-axis
      Vector3f zposition = new Vector3f(0.0f,0.0f,1.4f);
      renderobject3d.setText2DRender("Z", zposition, axisallTG);

      moleculedata.put("X", renderobject3d.hashShape3d.get("X"));
      moleculedata.put("Y", renderobject3d.hashShape3d.get("Y"));
      moleculedata.put("Z", renderobject3d.hashShape3d.get("Z"));
      moleculedata.put("XTG", renderobject3d.hashShape3d.get("XTG"));
      moleculedata.put("YTG", renderobject3d.hashShape3d.get("YTG"));
      moleculedata.put("ZTG", renderobject3d.hashShape3d.get("ZTG"));

      BranchGroup rootBG = new BranchGroup();
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      rootBG.setCapability( BranchGroup.ALLOW_DETACH );

      rootBG.addChild(axisallTG);
      locale.addBranchGraph( rootBG );

      return moleculedata;
  }

/*
  public class IdentityCallback extends Object implements PickingCallback{
	  private Transform3D t3d = new Transform3D();
      private Vector3f v = new Vector3f();

      public void transformChanged(int type, TransformGroup tg) {

		tg.getTransform( t3d );
		t3d.get ( v );
        System.out.println("picking"+ v);
      }
  }
*/

    public static void main(String[] args) {
	Frame frame = new MainFrame(new Java3DViewer(), 600, 400);
    }
}





