
/* Defining visual Object: Text2D, Sphere, Cylinder
 * Geometry Utilities: calculation of angles, the middle point, length
 * Representation of the Applearance for each visual objects
*/

package extensions.generic;

import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.Text2D;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Cylinder;
import java.util.HashMap;

   public class renderingObject3D {

	public HashMap hashShape3d;

	public renderingObject3D() {
	 
           hashShape3d = new HashMap();

	}

	/* Displaying the coordinate axis, X,Y,Z */
	public void setText2DRender(String coord, Vector3f position, TransformGroup sceneTG)
 	{

             Shape3D text2d = new Text2D(coord, 
                                      new Color3f(1.0f, 1.0f, 1.0f), 
                                      "Helvetica", 30, Font.PLAIN);
    	     text2d.setCapability( Shape3D.ALLOW_GEOMETRY_READ );
    	     text2d.setCapability( Shape3D.ALLOW_GEOMETRY_WRITE );

	     hashShape3d.put(coord, text2d);
	     Transform3D textTranslation = new Transform3D();
	     textTranslation.setTranslation(position);
	     TransformGroup textTranslationGroup = new TransformGroup(textTranslation);
             textTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
             textTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
             textTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
             textTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
             textTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
             textTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);

	     textTranslationGroup.addChild(text2d);
             String tgtmp = coord+"TG";
	     hashShape3d.put(tgtmp, textTranslationGroup);

	     sceneTG.addChild(textTranslationGroup);

             Appearance textAppear = text2d.getAppearance();

             // The following 4 lines of code (commented out) make the Text2D object
             // 2-sided.
             // This code depends on the line of code above that sets TextAppear.
             PolygonAttributes polyAttrib = new PolygonAttributes();
             polyAttrib.setCullFace(PolygonAttributes.CULL_NONE);
             polyAttrib.setBackFaceNormalFlip(true);
             textAppear.setPolygonAttributes(polyAttrib);

	}

	/* Render sphere */
	public void setSphereRender(float radius, Color3f appear_index, Vector3d position, 
                                    TransformGroup sceneTG)
	{
	    Sphere sphere = new Sphere(radius); 
            sphere.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
            sphere.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	    
	    Appearance sphereAppear = new Appearance();
	 
	    sphereAppear = createAppearance(appear_index);
	    sphere.setAppearance(sphereAppear);

	    Transform3D sphereTranslation = new Transform3D();
	    sphereTranslation.setTranslation(position);
	    TransformGroup sphereTranslationGroup = new TransformGroup(sphereTranslation);
            sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
            sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
            sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
            sphereTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
            sphereTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

	    sphereTranslationGroup.addChild(sphere);
	    sceneTG.addChild(sphereTranslationGroup);
	    hashShape3d.put("Sphere", sphereTranslationGroup);    

	}
	
	
	/* Render sphere */
	public void setSphereRenderAnimation(float radius, Color3f appear_index, double[] position, 
                 float[] normalPos, TransformGroup sceneTG, BranchGroup bg)
	{
	    Sphere sphere = new Sphere(radius); 
        sphere.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
        sphere.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	    
        //For animation, set variable
        Alpha alpha = new Alpha(-1, 500);
        Transform3D axisOfRotPos = new Transform3D();
        float[] knots = {0.0f, 1.0f};        
        Point3f[] positions = new Point3f[2];	    
	    Vector3f axis = new Vector3f(0.0f,0.0f,1.0f);
        axisOfRotPos.set(axis);	
        //BoundingSphere bounds1 = new BoundingSphere();	
	    Vector3d pos = new Vector3d(position[0], position[1], position[2]);
	    
	    positions[0] = new Point3f( (float)position[0], (float)position[1], (float)position[2]);
	    positions[1] = new Point3f( normalPos[0], normalPos[1], normalPos[2] );
	    
	    //Appareance setting   
	    Appearance sphereAppear = new Appearance();
	 
	    sphereAppear = createAppearance(appear_index);
	    sphere.setAppearance(sphereAppear);

	    Transform3D sphereTranslation = new Transform3D();
	    sphereTranslation.setTranslation(pos);
	    TransformGroup sphereTranslationGroup = new TransformGroup(sphereTranslation);
            sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
            sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
            sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
            sphereTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
            sphereTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
            
	    PositionPathInterpolator pospath = new PositionPathInterpolator(
	    	    alpha, sphereTranslationGroup, axisOfRotPos, knots, positions);
	    pospath.setSchedulingBounds(new BoundingSphere());	    

	    sphereTranslationGroup.addChild(sphere);
	    sceneTG.addChild(sphereTranslationGroup);
	    bg.addChild(pospath);
	    hashShape3d.put("Sphere", sphereTranslationGroup);

	}	
	
	
	/* Render cylinder */
	public void setCylinderRender(float radius, float height, Color3f appear_index,
                      Vector3d position, double[] firstvalue, double thetaz, double thetay, TransformGroup sceneTG)
	{
	    Cylinder cylinder = new Cylinder(radius, height); 
	    Appearance cylinderAppear = new Appearance();
	 
	    cylinderAppear = createAppearance(appear_index);
	    cylinder.setAppearance(cylinderAppear);

	    Transform3D cylinderTranslation = new Transform3D();
	    cylinderTranslation.setTranslation(position);
	    TransformGroup cylinderTranslationGroup = new TransformGroup(cylinderTranslation);
            cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
            cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
            cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
            cylinderTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
            cylinderTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	    hashShape3d.put("Cylinder", cylinderTranslationGroup);    

      BoundingSphere bounds1 = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
    
	    Transform3D cylinderrot = new Transform3D();
	    cylinderrot.rotX(thetaz);

	    Transform3D cylinderrot1 = new Transform3D();
	    cylinderrot1.rotY(thetay);
	    
	    cylinderrot1.mul(cylinderrot);

	    TransformGroup cylinderGroup = new TransformGroup(cylinderrot1);
	
	    cylinderTranslationGroup.addChild(cylinderGroup);
	    cylinderGroup.addChild(cylinder);
	    sceneTG.addChild(cylinderTranslationGroup);

	}

	/* Rendering bars */
	public void renderingBar(float radius, Color3f appear_index, double[] carbon, double[] hydrogen, TransformGroup sceneTG)
	{
	    double chlength = getLength(carbon,hydrogen);		
	    double[] chmidpoint = getMidPoint(carbon,hydrogen);
	    double thetaz;
	    double thetapai;

	    if((chmidpoint[1] == 0.0) || (chmidpoint[2] == 0.0))
	        thetaz = thetaAngle(carbon[1], chmidpoint[1], chlength);
	    else if (chmidpoint[2] > carbon[2])
	            thetaz = 2.0*Math.PI - thetaAngle(carbon[1],chmidpoint[1],chlength);
	    else thetaz = thetaAngle(carbon[1],chmidpoint[1],chlength);
	    
	    if((carbon[0] - chmidpoint[0]) == 0.0 && (carbon[2] - chmidpoint[2]) == 0.0)
		thetapai = 0.0;
	    else
	      thetapai = Math.atan((carbon[0] - chmidpoint[0]) / (carbon[2] - chmidpoint[2]));

	    double thetay = thetapai;

      	    Vector3d cylinderposition = new Vector3d(chmidpoint[0],chmidpoint[1],chmidpoint[2]);
      	    setCylinderRender(radius,(float)chlength,appear_index,
                                cylinderposition, carbon, thetaz,thetay,sceneTG);	
	}

	/* the length between two points */
	public double getLength(double[] point3d1, double[] point3d2)
	{
	    double length;
	    
            length = (point3d1[0] - point3d2[0])*(point3d1[0] - point3d2[0]) +
		       (point3d1[1] - point3d2[1])*(point3d1[1] - point3d2[1]) + 
                       (point3d1[2] - point3d2[2])*(point3d1[2] - point3d2[2]);

	    return Math.sqrt(length);
	}

	/*the center point between two points */
	public double[] getMidPoint(double[] point3d1, double[] point3d2)
 	{
	   double[] midpoint = new double[3];

	
	    midpoint[0] = (point3d1[0] + point3d2[0])/2.0;
	    midpoint[1] = (point3d1[1] + point3d2[1])/2.0;
	    midpoint[2] = (point3d1[2] + point3d2[2])/2.0; 
	
	    return midpoint;
	}

        /* X-axis rotation angle */
	public double thetaAngle(double targetY, double originY, double length)
	{
	    return Math.acos((targetY - originY)/(length/2.0));
	}

        /* Material(ambientColor,emissiveColor, diffuseColor, specularColor, shininess)
        */

	public Appearance createAppearance(Color3f objColor)
	{
	    Appearance app = new Appearance();

	    // Globally used colors
	    Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
	    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

	    // Set up the material properties
	    //Color3f objColor = new Color3f(0.0f, 1.0f, 0.0f);
	    app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));

	    return app;
	}

/*
        public Appearance createAppearance(int idx) {
	    Appearance app = new Appearance();

	    // Globally used colors
	    Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
	    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

	    switch (idx) {
	    // Unlit solid
	    case 0:
	    {
		// Set up the coloring properties
		Color3f objColor = new Color3f(1.0f, 0.2f, 0.4f);
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(objColor);
		app.setColoringAttributes(ca);
		break;
	    }

	    // Unlit wire frame
	    case 1:
	    {
		// Set up the coloring properties
		Color3f objColor = new Color3f(0.5f, 0.0f, 0.2f);
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(objColor);
		app.setColoringAttributes(ca);

		// Set up the polygon attributes
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(pa.POLYGON_LINE);
		pa.setCullFace(pa.CULL_NONE);
		app.setPolygonAttributes(pa);
		break;
	    }

	    // Unlit points
	    case 2:
	    {
		// Set up the coloring properties
		Color3f objColor = new Color3f(0.2f, 0.2f, 1.0f);
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(objColor);
		app.setColoringAttributes(ca);

		// Set up the polygon attributes
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(pa.POLYGON_POINT);
		pa.setCullFace(pa.CULL_NONE);
		app.setPolygonAttributes(pa);

		// Set up point attributes
		PointAttributes pta = new PointAttributes();
		pta.setPointSize(5.0f);
		app.setPointAttributes(pta);
		break;
	    }

	    // Lit solid
	    case 3:
	    {
		// Set up the material properties
		Color3f objColor = new Color3f(0.0f, 1.0f, 0.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    // Transparent, lit solid
	    case 4:
	    {
		// Set up the transparency properties
		TransparencyAttributes ta = new TransparencyAttributes();
		ta.setTransparencyMode(ta.BLENDED);
		ta.setTransparency(0.6f);
		app.setTransparencyAttributes(ta);

		// Set up the polygon attributes
		PolygonAttributes pa = new PolygonAttributes();
		pa.setCullFace(pa.CULL_NONE);
		app.setPolygonAttributes(pa);

		// Set up the material properties
		Color3f objColor = new Color3f(0.9f, 0.1f, 0.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    // Lit solid, specular only
	    case 5:
	    {
		// Set up the material properties
		Color3f objColor = new Color3f(0.9f, 0.1f, 0.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    // Another lit solid with a different color
	    case 6:
	    {
		// Set up the material properties
		Color3f objColor = new Color3f(1.0f, 0.0f, 1.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    default:
	    {
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(new Color3f(0.0f, 1.0f, 0.0f));
		app.setColoringAttributes(ca);
	    }
	}

	return app;
    }
*/

  }